
using NServiceBus;
using NServiceBus.Persistence;
using System.Linq;
using System.Threading.Tasks;

namespace DCKiss.IMG.NSBSagaUpdate.Worker_Test
{
    /*
		This class configures this endpoint as a Server. More information about how to configure the NServiceBus host
		can be found here: http://particular.net/articles/the-nservicebus-host
	*/

    public class EndpointConfig : IConfigureThisEndpoint, AsA_Server
    {
        public void Customize(EndpointConfiguration configuration)
        {
            MainAsync().Wait();
        }

        static async Task MainAsync()
        {
            var sourceQueue = "Queue";
            var storageConnectionString = "ConnectionString";
            var endpointConfiguration = new EndpointConfiguration(sourceQueue);
            var persistence = endpointConfiguration.UsePersistence<AzureStoragePersistence>();
            persistence.ConnectionString(storageConnectionString);

            endpointConfiguration.UsePersistence<AzureStoragePersistence, StorageType.Sagas>()
                .AssumeSecondaryIndicesExist();
            endpointConfiguration.UsePersistence<AzureStoragePersistence, StorageType.Subscriptions>();
            endpointConfiguration.UsePersistence<AzureStoragePersistence, StorageType.Timeouts>().TimeoutDataTableName("AzureTimeOut").TimeoutManagerDataTableName("AzureTimeOutManager");
            endpointConfiguration.UseSerialization<JsonSerializer>();
            endpointConfiguration.EnableInstallers();
            endpointConfiguration.SendFailedMessagesTo("error");
			var transport = endpointConfiguration.UseTransport<AzureStorageQueueTransport>();
            transport.ConnectionString(storageConnectionString);
            endpointConfiguration.UseSerialization<JsonSerializer>();
            var endpointInstance = await Endpoint.Start(endpointConfiguration)
                .ConfigureAwait(false);
            await endpointInstance.Stop()
                    .ConfigureAwait(false);
        }
    }
}
